<template>
    <v-card>
        <ValidationObserver ref="observer" v-slot="{ validate, reset }">
            <v-container class="px-8">
                <v-row class="pb-2">
                    <v-col cols="4" md="6" class="align-self-center flex-grow-1 flex-shrink-0">
                        <div class="title text--primary fill-height">
                            {{ $t(mode + '_', [$t('warehouse')]) }}
                        </div>
                    </v-col>

                    <v-spacer></v-spacer>

                    <v-col class="flex-grow-0 flex-shrink-1">
                        <v-switch class="toggle"
                                  v-model="localValue.default"
                                  :label="$t('default')"
                                  :true-value="1"
                                  :false-value="0"
                                  inset
                                  hide-details
                        >
                        </v-switch>
                    </v-col>

                    <v-col class="flex-grow-0 flex-shrink-1">
                        <v-switch class="toggle"
                                  v-model="localValue.enabled"
                                  :label="$t('enabled')"
                                  :true-value="1"
                                  :false-value="0"
                                  inset
                                  hide-details
                        >
                        </v-switch>
                    </v-col>
                </v-row>
                <v-divider></v-divider>


                <v-row>
                    <v-col>
                        <div class="subtitle-1 text--secondary">{{ $t('warehouse_', [$t('info')]) }}</div>
                    </v-col>
                </v-row>

                <v-row class="ml-2">

                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('country') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="country" rules="required">
                            <v-text-field
                                v-model="localValue.country"
                                :placeholder="$t('warehouse_', [$t('country')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('name') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="name" rules="required">
                            <v-text-field
                                v-model="localValue.name"
                                :placeholder="$t('warehouse_', [$t('name')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('slug') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="slug" rules="required">
                            <v-text-field
                                v-model="localValue.slug"
                                :placeholder="$t('warehouse_', [$t('slug')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('address1') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="address1" rules="required">
                            <v-text-field
                                v-model="localValue.address1"
                                :placeholder="$t('warehouse_', [$t('address1')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('address2') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="address2" rules="required">
                            <v-text-field
                                v-model="localValue.address2"
                                :placeholder="$t('warehouse_', [$t('address2')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col cols="12" md="6">
                        <div class="field-label">{{ $t('city') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="city" rules="required">
                            <v-text-field
                                v-model="localValue.city"
                                :placeholder="$t('warehouse_', [$t('city')])"
                                :error-messages="errors"
                                outlined
                            ></v-text-field>
                        </ValidationProvider>
                    </v-col>

                    <v-col class="col-xs-12 col-sm-12 col-md-12 col-lg-6">
                        <div class="field-label">{{ $t('mobile') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="phone" rules="required|mobile">
                            <v-tel-input
                                v-model="localValue.phone"
                                :defaultCountry="defaultCountry"
                                :placeholder="$t('warehouse_', [$t('mobile')])"
                                :errors="errors"
                            ></v-tel-input>
                        </ValidationProvider>
                    </v-col>

                    <v-col class="col-xs-12 col-sm-12 col-md-12 col-lg-6">
                        <div class="field-label">{{ $t('fax') }}</div>
                        <ValidationProvider v-slot="{ errors }" name="fax" rules="required|mobile">
                            <v-tel-input
                                v-model="localValue.fax"
                                :defaultCountry="defaultCountry"
                                :placeholder="$t('warehouse_', [$t('fax')])"
                                :errors="errors"
                            ></v-tel-input>
                        </ValidationProvider>
                    </v-col>

                </v-row>

                <v-row>
                    <v-col class="text-center">
                        <v-btn
                            v-if="clearable"
                            class="text--white mx-2"
                            color="error"
                            large
                            @click="internalClear"
                        >
                            <v-icon>mdi-clear</v-icon>
                            {{ $t('clear') }}
                        </v-btn>
                        <v-btn
                            class="text--white mx-2"
                            color="primary"
                            large
                            @click="internalSave"
                            :loading="submit"
                        >
                            <v-icon>mdi-content-save</v-icon>
                            {{ $t('save') }}
                        </v-btn>
                    </v-col>
                </v-row>
            </v-container>
        </ValidationObserver>
    </v-card>
</template>


<script>
  import {ValidationObserver, ValidationProvider} from "vee-validate";
  import VTelInput from "../VTelInput";
  import {mapMutations} from "vuex";

  export default {
      name: "WarehouseForm",
      components: {
          VTelInput,
          ValidationObserver,
          ValidationProvider,
      },
      props: {
          value: {
              type: Object,
              required: true,
          },
          clearable: {
              type: Boolean,
              default: true,
          },
          mode: {
              type: String,
              default: "create",
              validator: (value) => ["create", "edit"].indexOf(value) !== -1,
          },
      },

      data: () => ({
          submit: false,
          defaultCountry: "",
          dialog: false,
      }),

      computed: {
          localValue: {
              get() {
                  return this.value;
              },
              set(val) {
                  this.$emit("input", val);
              },
          },

          isEditMode() {
              return this.mode === "edit";
          },
      },

      mounted() {
          if (this.mode === "create") {
              this.ipLookup();
          }
      },
      methods: {
          ...mapMutations('snackbar', [
              'success',
              'error'
          ]),

          closeDialog() {
              this.dialog = false;
          },

          internalClear() {
              let defaultObject = {
                  name: '',
                  country: '',
                  slug: '',
                  address1: '',
                  address2: '',
                  city: '',
                  phone: '',
                  fax: '',
                  default: '',
                  enabled: ''
              };

              if (!this.isEditMode) {
                  defaultObject = {
                      ...defaultObject,
                  };
              }

              this.$emit("input", defaultObject);

              this.$refs.observer.reset();
          },

          internalSave() {
              this.submit = true;

              this.$refs.observer.validate().then((valid) => {
                  if (valid) {
                      this.callApi()
                          .then((data) => {
                              if (data.status === 200) {
                                  this.$router.push("/warehouse");
                              }
                          })
                          .catch(data => {
                              this.error(data.message);
                          })
                          .finally(() => {
                              this.submit = false;
                          });
                  } else {
                      this.submit = false;
                  }
              });
          },

          callApi() {
              if (this.isEditMode) {
                  return new Promise((resolve, reject) => {
                      axios
                          .put(`api/warehouses/${this.value.id}`, this.localValue)
                          .then((response) => {
                              this.success(this.$t('warehouse_action.updated'));
                              resolve({
                                  status: response.status,
                              });
                          })
                          .catch((error) => {
                              reject(error.response.data);
                          });
                  });
              } else {
                  return new Promise((resolve, reject) => {
                      axios
                          .post("api/warehouses", this.localValue)
                          .then((response) => {
                              this.success(this.$t('warehouse_action.created'));
                              resolve({
                                  status: response.status,
                              });
                          })
                          .catch((error) => {
                              reject(error.response.data);
                          });
                  });
              }
          },
          ipLookup() {
              axios
                  .get("http://ip-api.com/json")
                  .then(({data}) => {
                      this.defaultCountry = data.countryCode;
                  })
                  .catch((error) => {
                      console.error("Request failed http://ip-api.com/json");
                  });
          },
      },
  };
</script>

<style scoped>
</style>
